<?php
define('FILENAME', 'stored.dat');

class Value {
  var $id;
  var $email;
  var $flag;

  public function __construct($id, $email, $flag) {
    $this->id = $id;
    $this->email = $email;
    $this->flag = $flag;
  }

  public function echo_data() {
    echo "{$this->id}:{$this->email}:{$this->flag}";
  }

  public static function from_json($json) {
    $d = json_decode($json);
    return new Value($d->id, $d->email, $d->flag);
  }

  public function to_json() {
    return json_encode(array(
      'id'    => $this->id,
      'email' => $this->email,
      'flag'  => $this->flag,
    ));
  }
}

$value = new Value(123, 'test@example.com', 'Y');
// JSON化
$json = $value->to_json();

// 保存する
$fp = fopen(FILENAME, 'w');
fwrite($fp, $json);
fclose($fp);

// ファイルから取得して
$stored = implode('', @file(FILENAME));

// JSONから元に戻す
$restored_value = Value::from_json($stored);
$restored_value->echo_data();
?>
