<?php
// session handler
extension_loaded('tokyocabinet') || dl('tokyocabinet.so') || exit(1);

class TCSession
{
  private static $session_db;

  public static function open() {
    self::$session_db = new TCHDB();
    return self::$session_db->open(
      'casket.hdb',
      TCHDB::OWRITER | TCHDB::OCREAT);
  }

  public static function close() {
    return self::$session_db->close();
  }

  public static function read($session_id) {
    return self::$session_db->get($session_id);
  }

  public static function write($session_id, $session_data) {
    return self::$session_db->put($session_id, $session_data);
  }

  public static function destroy($id) {
    return self::$session_db->put($session_id, '');
  }

  // don't delete.
  public static function gc($max_lifetime) {
    return TRUE;
  }
}

//ini_set('session.gc_probability', 50);
ini_set('session.save_handler', 'user');

session_set_save_handler(
  array('TCSession', 'open'),
  array('TCSession', 'close'),
  array('TCSession', 'read'),
  array('TCSession', 'write'),
  array('TCSession', 'destroy'),
  array('TCSession', 'gc')
);

if (session_id() == ''){
  session_start();
}

// main

session_regenerate_id(false);

if (isset($_SESSION['counter'])) {
  $_SESSION['counter']++;
} else {
  $_SESSION['counter'] = 1;
}

echo '<br/>SessionID: '. session_id() .'<br/>Counter: '. $_SESSION['counter'];
?>
