<?php
extension_loaded('tokyocabinet') || dl('tokyocabinet.so') || exit(1);

try {
  $hdb = new TCHDB();

  $hdb->tune(131071, 4, 10, 0);
  $hdb->open('casket.hdb',
             TCHDB::OWRITER | TCHDB::OCREAT | TCHDB::OTRUNC);

  $hdb->put('gunyara', 'human being');
  $hdb->put('kiki', 'cat');
  $hdb->put('moru', 'guinea pig');
  $hdb->put('hamuwo', 'hamster');

  echo $hdb->get('kiki'), "\n";

  $hdb->out('gunyara');

  foreach ($hdb as $key => $value) {
    echo "$key:$value\n";
  }

  echo "{$hdb->path()} ({$hdb->rnum()} records, {$hdb->fsiz()} bytes)\n";

  $hdb->close();

  $hdb = new TCHDB();
  $hdb->open('casket.hdb',
             TCHDB::OWRITER | TCHDB::OCREAT | TCHDB::OTRUNC);

  $hdb->put('kiki', 'nya-');
  $hdb->putkeep('kiki', 'wan wan');
  echo $hdb->get('kiki'), "\n";

  $hdb->putkeep('cameraski', 'human being');
  echo $hdb->get('cameraski'), "\n";

  $hdb->putcat('kiki', 'nyan');
  echo $hdb->get('kiki'), "\n";

  for ($i = 0; $i < 1000; $i++) {
    $hdb->putasync("key$i", "value$i");
  }
  $hdb->sync();
  echo $hdb->get('key0'), "\n";
  echo $hdb->get('key999'), "\n";

  $hdb->optimize(131071, 4, 10, 0);

  echo "record number: {$hdb->rnum()}\n";
  $hdb->vanish();
  echo "record number: {$hdb->rnum()}\n";

  /*
  for ($i = 0; $i < 8; $i++) {
    echo $hdb->addint('counter_int', 1);
  }

  for ($i = 0; $i < 8; $i++) {
    echo $hdb->adddouble('counter_double', 3.14);
  }
  */

  $hdb->close();
} catch (TCException $e) {
  echo $e->getMessage(), "\n";
}
?>
