#!/usr/bin/ruby
require 'tokyocabinet'
include TokyoCabinet

hdb = HDB.new
begin
  raise 'tune' unless hdb.tune(131071, 4, 10, 0)
  raise 'open' unless hdb.open('casket.hdb', HDB::OWRITER |
                                             HDB::OCREAT |
                                             HDB::OTRUNC)
  unless hdb.put('gunyara', 'human being') and
         hdb.put('kiki', 'cat') and
         hdb.put('moru', 'guinea pig') and
         hdb.put('hamuwo', 'hamster')
    raise 'put'
  end

  if value = hdb.get('kiki')
    puts value
  else
    raise 'get'
  end

  hdb.each {|key, value|
    puts "#{key}:#{value}"
  }

  puts "#{hdb.path()} (#{hdb.rnum()} records, #{hdb.fsiz()} bytes)";

  raise 'close' unless hdb.close

  hdb = HDB.new

  raise 'open' unless hdb.open('casket.hdb', HDB::OWRITER |
                                             HDB::OCREAT |
                                             HDB::OTRUNC)
  raise 'put' unless hdb.put('kiki', 'nya-')
  begin
    raise 'putkeep' unless hdb.putkeep('kiki', 'wanwan')
  rescue
  end
  raise 'putkeep' unless hdb.putkeep('cameraski', 'human being')
  if value = hdb.get('kiki')
    puts value
  else
    raise 'get'
  end
  if value = hdb.get('cameraski')
    puts value
  else
    raise 'get'
  end

  raise 'putcat' unless hdb.putcat('kiki', 'nyan')
  if value = hdb.get('kiki')
    puts value
  else
    raise 'get'
  end

  1000.times {|i|
    raise 'putasync' unless hdb.putasync("key#{i}", "value#{i}")
  }
  raise 'sync' unless hdb.sync

  if value = hdb.get('key0')
    puts value
  else
    raise 'get'
  end

  if value = hdb.get('key999')
    puts value
  else
    raise 'get'
  end

  raise 'optimize' unless hdb.optimize(131071, 4, 10, 0)
  puts "record number: #{hdb.rnum}"
  raise 'vanish' unless hdb.vanish
  puts "record number: #{hdb.rnum}"

  8.times {|i|
    puts hdb.addint('counter_int', 1)
  }

  8.times {|i|
    puts hdb.adddouble('counter_double', 3.14)
  }
rescue => e
  ecode = hdb.ecode
  STDERR.printf("%s: %s\n", e.message, hdb.errmsg(ecode))
ensure
  hdb.close
end
